#include <stdlib.h>
#include "gate.H"

#include <iostream>

/* Signal event. */
void S_Gate::signal(char p, int v)
{ 
	if(v != value[p - 'a']) {
		value[p - 'a'] = v;
		dofwd(SpGetTime().GetTime() + 0.01 + 
		      (random() % 1000) / 100000.0, SpGetObjHandle());
	}
}
void S_Gate::forward()
{
	conobj->xmit(idchar(), SpGetSimObjKindId(), SpGetTime().GetTime(), 
		     eval());
}

//void S_Gate::signal(char p, int v)
//{ 
//	//cout << "signal(" << p << "," << v << ")" << SpGetTime().GetTime() << endl;
//
//	if(v != value[p - 'a']) {
//		value[p - 'a'] = v;
//		//dofwd(SpGetTime().GetTime() + 0.01, SpGetObjHandle());
//		conobj->xmit(idchar(), SpGetSimObjKindId(), 
//			     SpGetTime().GetTime() + 0.01 + 
//			     (random() % 1000) / 100000.0, eval());
//		//cout << " -- (changed) " << eval() << endl;
//	}
//}

/* Initialize and make first connection. */
void S_Gate::Init()
{
	size = conobj->insize(idchar(), SpGetSimObjKindId());
	value = new RB_int[size];
	int in = initin();
	for(int n = 0; n < size; n++) value[n] = in;
	conobj->xmit(idchar(), SpGetSimObjKindId(), 0.0, initout());
}

/* Find the output value for each gate type. */
int S_And_Gate::eval()
{ 
	for(int n = 0; n < size; n++) if(!value[n]) return 0;
	return 1;
}
void S_And_Gate::dofwd(double t, SpObjHandle h) { 
	SCHEDULE_a_fwd(t, h); 
}

int S_Or_Gate::eval()
{ 
	for(int n = 0; n < size; n++) if(value[n]) return 1;
	return 0;
}
void S_Or_Gate::dofwd(double t, SpObjHandle h) { 
	SCHEDULE_o_fwd(t, h); 
}

int S_Xor_Gate::eval()
{ 
	int ret = size ? 0 : (int)value[0];

	for(int n = 1; n < size; n++) ret = ret ^ !!value[n];
	return ret;
}
void S_Xor_Gate::dofwd(double t, SpObjHandle h) { 
	SCHEDULE_x_fwd(t, h); 
}

int S_Not_Gate::eval()
{ 
	return !value[0];
}
void S_Not_Gate::dofwd(double t, SpObjHandle h) { 
	SCHEDULE_n_fwd(t, h); 
}
