#include <stdlib.h>
#include <string>
#include <strstream>
#include "gen.H"
#include "gate.H"
//#include "RB_ostream.H" 

/* Start the first event. */
void S_generator::Init() 
{
	mindelay = 3;
	maxdelay = 5;

	std::string s = conobj->parms('G', SpGetSimObjKindId());
	if(s != "") std::istrstream(s.c_str()) >> mindelay >> maxdelay;

	conobj->xmit('G', SpGetSimObjKindId(), 0.0, 0);
	SCHEDULE_genev(later(0.0), SpGetObjHandle());
}

/* When to schedule the next event. */
double S_generator::later(double base)
{
	if(base < 0.0) base = SpGetTime().GetTime();
	return base + random() % (maxdelay - mindelay + 1) + mindelay;
}

void S_generator::gen()
{

	double now = SpGetTime().GetTime();
	int what = random() % 2;

	//RB_cout << "t=" << now
	//	<< ": G" << SpGetSimObjKindId() << " set "  << what << endl;

	conobj->xmit('G', SpGetSimObjKindId(), now, what);

	double lat = later();
	if(lat <= conobj->stopat())
		SCHEDULE_genev(lat, SpGetObjHandle());
}
